# Coveo Breadcrumb Component (CoveoBreadcrumb)

The Breadcrumb component displays a summary of the currently active query filters.

For example, when the user selects a Facet value, the breadcrumbs display this value.

The active filters are obtained by the component by firing an event in the Breadcrumb component.

All other components having an active state can react to this event by providing custom bits of HTML to display inside the breadcrumbs.

Thus, it is possible to easily extend the Breadcrumb component using custom code to display information about custom states and filters.

See BreadcrumbEvents for the list of events and parameters sent when a Breadcrumb component is populated.

## Index

### Methods

- clearBreadcrumbs
- debugInfo
- disable
- drawBreadcrumb
- enable
- getBindings
- getBreadcrumbs
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- headingLevel

### Constructors

- constructor

## Methods

### clearBreadcrumbs

- clearBreadcrumbs(): void

- - Defined in ui/Breadcrumb/Breadcrumb.ts :107

  Triggers the event to clear the current breadcrumbs that components such as Facet can populate.

  Also triggers a new query and logs the `breadcrumbResetAll` event in the usage analytics.

  #### Returns void

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### drawBreadcrumb

- drawBreadcrumb(breadcrumbs: IBreadcrumbItem[]): void

- - Defined in ui/Breadcrumb/Breadcrumb.ts :119

  Draws the specified breadcrumb items.

  #### Parameters

  - ##### breadcrumbs: IBreadcrumbItem[]

    The breadcrumb items to draw.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getBreadcrumbs

- getBreadcrumbs(): IBreadcrumbItem[]

- - Defined in ui/Breadcrumb/Breadcrumb.ts :86

  Triggers the event to populate the breadcrumbs. Components such as Facet can populate the breadcrumbs.

  This method triggers a BreadcrumbEvents.populateBreadcrumb event with an IPopulateBreadcrumbEventArgs object (an array) that other components or code can populate.

  #### Returns IBreadcrumbItem[]

  A populated breadcrumb item list.

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### headingLevel

headingLevel: number

- Defined in ui/Breadcrumb/Breadcrumb.ts :48

The heading level to use for the heading before the breadcrumbs.

A value of 0 will render a `div` element instead.

Minimum

  `0`

Maximum

  `6`

Markup configuration example(s) :

    data-heading-level='10'

## Constructors

### constructor

- new Breadcrumb(element: HTMLElement, options?: IBreadcrumbOptions, bindings?: IComponentBindings): Breadcrumb

- Overwrites Component.constructor

  - Defined in ui/Breadcrumb/Breadcrumb.ts :57

  Creates a new Breadcrumb component. Binds event on QueryEvents.deferredQuerySuccess to draw the breadcrumbs.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: IBreadcrumbOptions

    The options for the Breadcrumb component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns Breadcrumb